<template>
  <v-container>
    <v-dialog v-model="dialog" persistent>
      <v-card>
        <v-card-title>
          <span v-text="title" />
        </v-card-title>
        <v-card-text>
          <v-container>
            <v-row>
              <v-col cols="12">
                <v-text-field label="Username*" v-model="user.username" required readonly />
              </v-col>
            </v-row>
            <v-row>
              <v-col cols="12">
                <v-text-field label="Password*" v-model="user.old_password" type="password" :disabled="statusProgress" v-if="isEdit" :error-messages="error_payload.old_password" />
              </v-col>
            </v-row>
            <v-row>
              <v-col cols="12">
                <v-text-field label="New Password*" v-model="user.new_password" type="password" :disabled="statusProgress" :error-messages="error_payload.new_password" />
              </v-col>
            </v-row>
            <v-row>
              <v-col cols="12">
                <v-text-field label="Password Confirm*" v-model="user.confirm_password" type="password" :disabled="statusProgress" :error-messages="error_payload.confirm_password" />
              </v-col>
            </v-row>
          </v-container>
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="blue darken-1" text @click="doSave" :disabled="statusProgress">Simpan</v-btn>
          <v-btn color="blue darken-1" text @click="doReset" :disabled="statusProgress">Reset</v-btn>
          <v-btn color="blue darken-1" text @click="doClose" :disabled="statusProgress">Close</v-btn>
        </v-card-actions>
      </v-card>
      <DlgMsg ref="dlgMsg" />
      <Loading ref="loading" :dlg-loading="statusProgress" />
    </v-dialog>
  </v-container>
</template>

<script>
import DlgMsg from "../components/dialog/DlgMsg";
import Loading from "../components/dialog/Loading";

import userService from "../service/UserService";
import {checkError400} from "../utils/util";

export default {
  name: "UserResetForm",
  components: {
    DlgMsg,
    Loading,
  },
  data: function () {
    return {
      user: {
        username: null,
        old_password: null,
        new_password: null,
        confirm_password: null,
      },
      error_payload: {
        username: [],
        old_password: [],
        new_password: [],
        confirm_password: [],
      },
      title: null,
      dialog: false,
      isEdit: false,
      statusProgress: false,
    }
  },
  methods: {
    doClose() {
      this.dialog = false
    },
    doEdit(username, title, isEdit) {
      this.title = title
      this.setResetError()
      this.dialog = true
      this.isEdit = isEdit
      this.retrieveUser(username)
    },
    doReset() {
      this.user.old_password = null
      this.user.new_password = null
      this.user.confirm_password = null

      this.setResetError()
    },
    setResetError() {
      this.error_payload.old_password = []
      this.user.new_password = []
      this.error_payload.confirm_password = []
    },
    async doSave() {
      let data = this.user
      let param = 1
      if (!this.isEdit) {
        param = 0
      }
      this.statusProgress = true
      await userService.resetPassword(data, param)
          .then(async res => {
            if (res.data.status === "SUCCESS") {
              if (!this.isEdit) {
                await this.$parent.doRefresh()
              }
              this.doReset()
              this.dialog = false
            }
            this.$refs.dlgMsg.doOpenMsg(res.data.message)
          })
          .catch(ex => {
            checkError400(ex, this.$refs.dlgMsg, this.error_payload)
          })
      this.statusProgress = false
    },
    async retrieveUser(username) {
      this.statusProgress = true
      await userService.getByUsername(username)
          .then(res => {
            let status = res.data.status
            if (status === 'SUCCESS') {
              let user = res.data.data
              this.user.username = user.username
            } else {
              this.$refs.dlgMsg.doOpenMsg(res.data.data.message)
            }
          }).catch(ex => {
            console.log(ex)
            this.$refs.dlgMsg.doOpenMsg(ex)
      })
      this.statusProgress = false
    },
  },
}
</script>

<style scoped>

</style>